"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getDiffFiles = getDiffFiles;
exports.getDiffJsonPath = getDiffJsonPath;
exports.getReportPath = getReportPath;
exports.getRootDir = getRootDir;
exports.gitDiffFiles = gitDiffFiles;
exports.runEslintForDiff = runEslintForDiff;
var _child_process = require("child_process");
var _path = _interopRequireDefault(require("path"));
var _logger = require("../utils/logger");
var _cliArgsToObject2 = require("../utils/cliArgsToObject");
var _fileUtils = require("../utils/fileUtils");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == _typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator["return"] && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, "catch": function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
// import { requestJAR } from './requestJarAPI';
function runEslintForDiff(cliParams) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  // $(git diff --name-only HEAD HEAD~1 | grep -E '\.(js|jsx)$' | xargs)
  // await requestJAR(cliParams);
  var _cliArgsToObject = (0, _cliArgsToObject2.cliArgsToObject)(cliParams),
    _cliArgsToObject$diff = _cliArgsToObject.diffPath,
    diffPath = _cliArgsToObject$diff === void 0 ? null : _cliArgsToObject$diff,
    _cliArgsToObject$lint = _cliArgsToObject.lintEnv,
    lintEnv = _cliArgsToObject$lint === void 0 ? null : _cliArgsToObject$lint;
  var format = "json";
  var reportPath = getReportPath();
  var diffJSON = diffPath ? require(getDiffJsonPath(diffPath)) : null;
  var filteredDiffFiles = getDiffFiles(diffJSON);
  var lintFiles = !filteredDiffFiles ? [_path["default"].resolve(process.cwd(), "uat")] : filteredDiffFiles;
  if (lintEnv === "pre-commit") {
    lintFiles = gitDiffFiles();
  }
  return new Promise(function (resolve) {
    var command = ["eslint", lintFiles.join(" "), "--format=".concat(format), "-o", "".concat(reportPath)];
    try {
      var lint_process = (0, _child_process.spawn)("npx", command, {
        shell: true,
        cwd: process.cwd()
      });
      lint_process.stdout.on("data", function (data) {
        _logger.Logger.log(_logger.Logger.INFO_TYPE, data);
      });
      lint_process.stderr.on("error", function (err) {
        _logger.Logger.log(_logger.Logger.FAILURE_TYPE, err);
      });
      lint_process.on("error", function (errors) {
        _logger.Logger.log(_logger.Logger.FAILURE_TYPE, errors);
      });
      lint_process.on("close", /*#__PURE__*/function () {
        var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(onclose) {
          var filteredJson;
          return _regeneratorRuntime().wrap(function _callee$(_context) {
            while (1) switch (_context.prev = _context.next) {
              case 0:
                if (!(diffPath && !(filteredDiffFiles.length === 0))) {
                  _context.next = 5;
                  break;
                }
                _context.next = 3;
                return filterReportBasedDiff(require(reportPath), diffJSON);
              case 3:
                filteredJson = _context.sent;
                (0, _fileUtils.writeFileContents)(reportPath, JSON.stringify(filteredJson));
              case 5:
                resolve({
                  status: "success"
                });
              case 6:
              case "end":
                return _context.stop();
            }
          }, _callee);
        }));
        return function (_x) {
          return _ref.apply(this, arguments);
        };
      }());
    } catch (error) {
      _logger.Logger.log(_logger.Logger.INFO_TYPE, error);
      _logger.Logger.log(_logger.Logger.FAILURE_TYPE, "Execution Failed");
    }
  });
}
function filterReportBasedDiff(resultJson, diffJson) {
  return new Promise(function (resolve) {
    if (!diffJson) {
      _logger.Logger.log(_logger.Logger.FAILURE_TYPE, "git diff json is not given ...");
      resolve(false);
    }
    var impactLineMap = filterDiffJson(diffJson);
    resultJson = resultJson.filter(function (result) {
      var _impactLineMap$get;
      var isImpactFile = result.filePath;
      if (isImpactFile.includes(".feature")) {
        return false;
      }
      if (!isImpactFile) {
        return false;
      }
      if (((_impactLineMap$get = impactLineMap.get(isImpactFile)) === null || _impactLineMap$get === void 0 ? void 0 : _impactLineMap$get.length) !== 0) {
        result.messages = result.messages.filter(function (errorMsg) {
          if (impactLineMap.get(isImpactFile).includes("".concat(errorMsg.line))) {
            return true;
          }
          return false;
        });
        return true;
      }
    });
    resolve(resultJson);
  });
}
function filterDiffJson(diffJson) {
  var _diffJson$diffs;
  var diffFilesMap = new Map();
  diffJson === null || diffJson === void 0 || (_diffJson$diffs = diffJson.diffs) === null || _diffJson$diffs === void 0 || _diffJson$diffs.forEach(function (diff) {
    var diffMatch = [];
    var regex = /@@(.*?)@@/g;
    var match;
    while ((match = regex.exec(diff.diff)) !== null) {
      diffMatch.push.apply(diffMatch, _toConsumableArray(splitFilterNumber(match[1])));
    }
    var diffPathKey = _path["default"].resolve(getRootLintPath(), diff.new_path);
    if (diffPathKey === undefined) {
      return;
    }
    if (diffPathKey) {
      diffFilesMap.set(diffPathKey, diffMatch);
    }
  });
  return diffFilesMap;
}
function getRootDir() {
  return process.cwd();
}
function getPathFromTestDir(diffPath) {
  if (!diffPath.includes("uat")) {
    return undefined;
  }
  var indexOfDiff = diffPath.split("/").indexOf("uat");
  var diffActualPath = diffPath.split("/").slice(indexOfDiff).join("/");
  return diffActualPath;
}
function splitFilterNumber(numberString) {
  var resultedNum = [];
  numberString.split(" ").join(",").split(",").filter(function (element) {
    if (element.startsWith("-")) {
      resultedNum.push(element.replace("-", " ").trim());
      // return element.replace('-', ' ').trim();
      return true;
    }
    if (element.startsWith("+")) {
      resultedNum.push(element.replace("+", " ").trim());
      return true;
    }
    return false;
  });
  return resultedNum;
}
function getDiffFiles(diffJson) {
  if (!diffJson) {
    return null;
  }
  var rootPath = getRootLintPath();
  return diffJson === null || diffJson === void 0 ? void 0 : diffJson.diffs.map(function (diff) {
    return _path["default"].resolve(rootPath, diff === null || diff === void 0 ? void 0 : diff.new_path);
  });
}
function getReportPath() {
  var reportPath = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  var reportOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var jsonReportPath = reportPath || _path["default"].resolve(process.cwd(), "uat", "lint-report", "lintReport.json");
  return jsonReportPath;
}
function getDiffJsonPath(diffJsonPath) {
  return _path["default"].resolve(diffJsonPath);
}
function gitDiffFiles() {
  var command = "git diff --cached -U0 HEAD --name-only";
  var child = (0, _child_process.spawnSync)(command, {
    shell: true
  });
  var diffFiles = child.stdout.toString().split("\n").map(function (filePath) {
    return _path["default"].resolve(getRootLintPath(), filePath);
  });
  diffFiles.pop(); // remove last empty string
  return diffFiles;
}
function getRootLintPath() {
  var childProcess = (0, _child_process.spawnSync)("git", ["rev-parse", "--show-toplevel"], {
    shell: true
  });
  return childProcess.stdout.toString().split("\n").filter(Boolean).pop();
}

// function validateReport() {
//   if (1) {
//   } else {
//     throw new Error('Report Failed');
//     process.exit(1);
//   }
// }