"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.showMsgPopUp = showMsgPopUp;
var _startSeverSonarQube = require("./startSever-sonarQube");
var _path = _interopRequireDefault(require("path"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function showMsgPopUp(condition) {
  // java -jar ./IDEMessagePluginRecent.jar project_name "BothStagedAndUnstaged"  server_url java_version_output
  var command = 'java';
  var params = ['-jar', "".concat(getPopupJarPath()), (0, _startSeverSonarQube.getProjectNameFrmGit)(), condition, 'java version 11'];
  switch (condition) {
    case 'NoIssueFound':
      (0, _startSeverSonarQube.getSpawnOutput)(command, params);
      break;
    case 'IssueFound':
      (0, _startSeverSonarQube.getSpawnOutput)(command, params);
      break;
    case 'BothStagedAndUnstaged':
      (0, _startSeverSonarQube.getSpawnOutput)(command, params);
      break;
    default:
      break;
  }
}
function getPopupJarPath() {
  return _path["default"].resolve(__dirname, 'java-jar', 'IDEMessagePluginRecent.jar');
}